unit Features;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Tqryqbe, ExtCtrls, TLabDBEd, StdCtrls,
  DBCtrls, Tcombqbe, QBETypes, Mask, Tdbedqbe, Tedqbe, Tchkqbe,
  Trngqbe, Grids, DBGrids, Tfldqbe;

type
  TForm2 = class(TForm)
    QueryQBE1: TQueryQBE;
    DataSource1: TDataSource;
    QueryQBE1CustNo: TFloatField;
    QueryQBE1Company: TStringField;
    QueryQBE1Addr1: TStringField;
    QueryQBE1Addr2: TStringField;
    QueryQBE1City: TStringField;
    QueryQBE1State: TStringField;
    QueryQBE1Zip: TStringField;
    QueryQBE1Country: TStringField;
    QueryQBE1Phone: TStringField;
    QueryQBE1FAX: TStringField;
    QueryQBE1TaxRate: TFloatField;
    QueryQBE1Contact: TStringField;
    QueryQBE1LastInvoiceDate: TDateTimeField;
    QueryQBE1Company_sx: TStringField;
    QueryQBE1City_sx: TStringField;
    QueryQBE1Contact_sx: TStringField;
    Button1: TButton;
    LabeledEditQBE1: TLabeledEditQBE;
    GroupBox1: TGroupBox;
    chkExWhenEmpty: TCheckBox;
    chkShowSQL: TCheckBox;
    GroupBox2: TGroupBox;
    RadioGroup1: TRadioGroup;
    Button2: TButton;
    Button3: TButton;
    RadioGroup2: TRadioGroup;
    GroupBox3: TGroupBox;
    RadioGroup3: TRadioGroup;
    chkInvert: TCheckBox;
    GroupBox4: TGroupBox;
    chkDispCompare: TCheckBox;
    chkFields: TCheckBox;
    chkUseSoundex: TCheckBox;
    DBGrid1: TDBGrid;
    FieldListQBE1: TFieldListQBE;
    procedure Button1Click(Sender: TObject);
    procedure LabeledEditQBE1Change(Sender: TObject);
    procedure chkExWhenEmptyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkShowSQLClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure chkFieldsClick(Sender: TObject);
  private
    { Private declarations }
    QBEActive: Boolean;
    procedure setFieldMode(Value: eModeOptions);
    procedure setCalendar(Value: eCalendarOptions);
    procedure setCompareOptions(DispValue: BOOLEAN; CompValue: eCompareOptions; Invert: BOOLEAN);
    procedure setFields(Allow: BOOLEAN);
    procedure setSoundex(Allow: BOOLEAN);
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.Button1Click(Sender: TObject);
begin
  if QBEActive then begin
    QueryQBE1.ExecQBE;
    setFieldMode(edit);
    QBEActive := False;
  end
  else
    showMessage(' Not in QBE Mode !');
end;

procedure TForm2.LabeledEditQBE1Change(Sender: TObject);
begin
  showMessage('Change');
end;

procedure TForm2.chkExWhenEmptyClick(Sender: TObject);
begin
  QueryQBE1.ExceptionWhenEmpty := chkExWhenEmpty.Checked;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  chkExWhenEmpty.Checked := QueryQBE1.ExceptionWhenEmpty;
  chkShowSQL.Checked := QueryQBE1.ShowSQL;
  chkDispCompare.Checked := True;
  QBEActive := False;
end;

procedure TForm2.chkShowSQLClick(Sender: TObject);
begin
  QueryQBE1.ShowSQL := chkShowSQL.Checked;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin

  If RadioGroup1.ItemIndex = 0 then
    setFieldMode(qbe)
  else
    setFieldMode(qbecombo);

  case RadioGroup3.ItemIndex of
    0:
      setCompareOptions(chkDispCompare.Checked,equal,chkInvert.Checked);
    1:
      setCompareOptions(chkDispCompare.Checked,less,chkInvert.Checked);
    2:
      setCompareOptions(chkDispCompare.Checked,greater,chkInvert.Checked);
  end;
  setSoundex(chkUseSoundex.Checked);
  QBEActive := True;
end;

procedure TForm2.setFieldMode(Value: eModeOptions);
var
  i: Integer;
begin

  for i := 0 to ControlCount - 1 do begin
    if Controls[i] is TLabeledEditQBE then
      (Controls[i] as TLabeledEditQBE).Mode := Value;
  end;

end;

procedure TForm2.setCompareOptions(DispValue: BOOLEAN; CompValue: eCompareOptions; Invert: BOOLEAN);
var
  i: Integer;
begin

  for i := 0 to ControlCount - 1 do begin
    if Controls[i] is TLabeledEditQBE then begin
      (Controls[i] as TLabeledEditQBE).DisplayCompare := DispValue;
      (Controls[i] as TLabeledEditQBE).Compare := CompValue;
      (Controls[i] as TLabeledEditQBE).Invert := chkInvert.Checked;
    end;
  end;

end;

procedure TForm2.setFields(Allow: BOOLEAN);
var
  i: Integer;
begin

  for i := 0 to ControlCount - 1 do begin
    if Controls[i] is TLabeledEditQBE then begin
      (Controls[i] as TLabeledEditQBE).ShowFields := Allow;
    end;
  end;

end;

procedure TForm2.setSoundex(Allow: BOOLEAN);
var
  i: Integer;
begin

  for i := 0 to ControlCount - 1 do begin
    if Controls[i] is TLabeledEditQBE then begin
      (Controls[i] as TLabeledEditQBE).UseSoundex := Allow;
    end;
  end;

end;

procedure TForm2.setCalendar(Value: eCalendarOptions);
var
  i: Integer;
begin

  for i := 0 to ControlCount - 1 do begin
    if Controls[i] is TLabeledEditQBE then
      (Controls[i] as TLabeledEditQBE).Calendar := Value;
  end;

end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  if QBEActive then begin
    setFieldMode(edit);
    QBEActive := False;
  end
  else
    showMessage(' Not in QBE Mode !');

end;

procedure TForm2.RadioGroup2Click(Sender: TObject);
begin
  case RadioGroup2.ItemIndex of
    0:
      setCalendar(Disable);
    1:
      setCalendar(DropDown);
    2:
      setCalendar(Popup);
  end;
end;

procedure TForm2.chkFieldsClick(Sender: TObject);
begin
  setFields(chkFields.Checked);
end;

end.
